# EdgeNode Micro App

EdgeNode is a front-end Micro App.

## Install

### use npm

```
npm install edge-node-micro-app
```

### or use yarn

```
yarn add edge-node-micro-app
```

## Usage

Before that, you must have installed the VueRouter.

For example:

```javascript
import router from '../router'
import registerEdgeNodeMicroApp from 'edge-node-micro-app'

const logo = 'xxxx'
const onlineIcon = 'xxx'
const offlineIcon = 'xxx'

registerEdgeNodeMicroApp({
  autoRegister: {
    router,
    parentRouterName: 'basic',
    routerMeta: {},
  },
  name: 'node-admin',
  activeRule: '/node-admin/',
  entry: 'http://localhost:3000',
  props: {
    token: 'xxx',
    apiHost: 'http://127.0.0.1:8080',
    socketHost: 'http://127.0.0.1:8080',
    design: {
      primaryColor: '#f15713',
      appName: '',
      appIcon: logo,
    },
    node: {
      onlineIcon,
      offlineIcon,
      onlineColor: '#6acc25',
      offlineColor: '#ed5653',
      background: '#171717',
      color: '#ffffff',
    },
    beforeDelete: () => {
      Promise.then(true)
    },
  },
})
```

Then you can display the page by configuring node-manager(`'/node-admin/'`) and image-version(`'/node-admin/image'`) in any menu.

## EdgeNode Micro App Basic Props

| Param            | Desc                                                                                                         | Required |
| ---------------- | ------------------------------------------------------------------------------------------------------------ | -------- |
| router           | VueRouter Instance                                                                                           | yes      |
| parentRouterName | Parent Router Name, Which parent route do you want to place the route under, usually in a layout with a menu | no       |
| routerMeta       | Custom Meta，Configure according to the meta supported by your current project                               | no       |
| entry            | Micro App URL                                                                                                | yes      |
| props            | MicroApp Props                                                                                               | no       |

## Qiankun Props

| Param      | Desc      | Required |
| ---------- | --------- | -------- |
| token      | Api token | yes      |
| apiHost    | Api Host  | no       |
| socketHost | Ws Host   | no       |

## MicroApp Design Props

| Param        | Desc           | Required |
| ------------ | -------------- | -------- |
| primaryColor | Primary Color  | no       |
| appName      | Micro App name | no       |
| appIcon      | Micro App icon | no       |

## MicroApp EdgeNode Manage Props

| Param        | Desc                                           | Required |
| ------------ | ---------------------------------------------- | -------- |
| onlineIcon   | Online Icon                                    | no       |
| offlineIcon  | Offline Icon                                   | no       |
| onlineColor  | Online Text Color                              | no       |
| offlineColor | Offline Text Color                             | no       |
| background   | Node Background                                | no       |
| color        | Node Font Color                                | no       |
| beforeDelete | 删除节点前回调 async ():Promise<boolean> => {} | no       |
