import { registerMicroApps as registerQiankunMicroApps } from 'qiankun'
import Page from './pages/index.vue'

const registerEdgeNodeMicroApp = (options = {}) => {
  const { autoRegister, name, activeRule, entry, props } = options
  if (autoRegister) {
    const { router, parentRouterName, routerMeta } = autoRegister
    registerRouter(router, parentRouterName, routerMeta)
  }
  registerMicroApps(name, activeRule, entry, props)
}

function registerRouter(router, parentRouterName, meta, activeRule) {
  if (!router) return

  const config = {
    path: `${activeRule}*`,
    component: Page,
    meta,
  }
  const params = parentRouterName ? [parentRouterName, config] : [config]

  router.addRoute.apply(router, [...params])
}

function registerMicroApps(name = 'node-admin', activeRule = '/node-admin/', entry, props) {
  registerQiankunMicroApps([
    {
      name,
      entry,
      container: '#qiankun',
      props,
      activeRule,
    },
  ])
}

export default registerEdgeNodeMicroApp
